
! By Chris Antonopoulos

program FPUb_LEs_si_Yoshida
implicit none

real(kind=8),external		:: solved_hamiltonian_function, kinetic_energy_function, potential_energy_function, kinetic_energy_derivative_function, potential_energy_derivative_function, Tq1
real(kind=8),allocatable	:: q(:), q_neighbor_1(:), q_neighbor_2(:), q_difference(:), qnorm(:), suma(:), LEs(:), array_nrg(:)
real(kind=8),allocatable	:: vector_1(:), vector_2(:)
real(kind=8),allocatable	:: LE1_vector_embedding_kin_and_pot_nrg(:)
real(kind=8)				:: t, t0, tf, tstep
real(kind=8)				:: relative_energy_error, hamiltonianenergy, hamiltonianenergy_q, hamiltonianenergy_q_neighbor_1, hamiltonianenergy_q_neighbor_2
real(kind=8)				:: alpha_LE1_network, sum_LE1_network, LE1_network, initial_distance_LE1_network, current_distance_LE1_network
real(kind=8)				:: alpha_LE2_network, sum_LE2_network, LE2_network, initial_distance_LE2_network, current_distance_LE2_network
real(kind=8)				:: sum_time_average_Tq1, Tq1_old
real(kind=8)				:: alpha_LE1_embedding_kin_and_pot_nrg, sum_LE1_embedding_kin_and_pot_nrg, LE1_embedding_kin_and_pot_nrg, initial_distance_LE1_embedding_kin_and_pot_nrg, current_distance_LE1_embedding_kin_and_pot_nrg
real(kind=8)				:: alpha_LE2_embedding_kin_and_pot_nrg, sum_LE2_embedding_kin_and_pot_nrg, LE2_embedding_kin_and_pot_nrg, initial_distance_LE2_embedding_kin_and_pot_nrg, current_distance_LE2_embedding_kin_and_pot_nrg
real(kind=8)				:: alpha, sum_LE1, LE1, in_dist, cur_dist
real(kind=8)				:: initial_energy_TDH, relative_energy_error_TDH
real(kind=8)				:: beta, nmax, ii, c, c_neighbor, perturbation, IcLE, maxdK_dt, dK_dt, H_KS_entropy, sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg, sum_time_average_abs_dk_over_LE1_Ham_vs_nrg
real(kind=8)				:: kappa_modulus2, solutionkappamodulus1, solutionkappamodulus2, solutionkappamodulus3, solutionkappamodulus4
real(kind=8)				:: min_nrg, max_nrg, number_of_steps_nrg
real(kind=8)				:: kinetic_energy_old, potential_energy_old
real(kind=8)				:: nrg_input
real(kind=4)				:: time_begin
integer(kind=4)				:: ndof, ndof2, si, i, j, k, index
integer(kind=4)				:: numfile_info, numfile_rel_ham_err, numfile_Lyap_exps, numfile_LEs_plot_gnu, numfile_IcLE_and_maxdK_dt_vs_nrg, numfile_IcLE_and_maxdK_dt_vs_nrg_gnu, numfile_ts_dK_dt_vs_K, numfile_ts_K_vs_P, numfile_traj, numfile_cobweb_kinetic_energy, numfile_LEs_network_KP_space, numfile_LEs_Benettin_network, numfile_LEs_Benettin_numerical_diff, numfile_kinetic_nrg_derivative
integer(kind=4)				:: min_number_of_nrg, max_number_of_nrg
integer(kind=4)				:: multiple, numberofdeviationvectors, counternrg
character(*)				:: filename_input_parameters
parameter(filename_input_parameters='input.in')
character(26)				:: char_numfile_Lyap_exps
character*(*)				:: file_name_LE
parameter(file_name_LE='fpu_LE')
character*(*)				:: file_name_output
parameter(file_name_output='')
character(1)				:: char_ndof_1
character(2)				:: char_ndof_2
character(3)				:: char_ndof_3
character(6)				:: char_nrg_1
character(7)				:: char_nrg_2
character(8)				:: char_nrg_3
character(9)				:: char_nrg_4
character(10)				:: char_nrg_5
character(26)				:: arg_nrg, arg_nrg_counter
character(4)				:: char_counternrg
common /param1/ beta
common /param2/ hamiltonianenergy

call cpu_time(time_begin)

!here we read from the command prompt the Hamiltonian energy
!the old way to read from the command prompt
!call getarg(1,arg_nrg)
!call getarg(2,arg_nrg_counter)

!the new way to read from the command prompt
call get_command_argument(1,arg_nrg)
call get_command_argument(2,arg_nrg_counter)

read(arg_nrg,'(f26.16)') nrg_input
read(arg_nrg_counter,'(i4)') counternrg

write(char_counternrg,'(i4)') counternrg

call read_input_parameters(perturbation,t0,tf,tstep,beta,si,ndof,numberofdeviationvectors,numfile_info,numfile_rel_ham_err,numfile_Lyap_exps,filename_input_parameters,numfile_LEs_plot_gnu,numfile_IcLE_and_maxdK_dt_vs_nrg,numfile_IcLE_and_maxdK_dt_vs_nrg_gnu,numfile_ts_dK_dt_vs_K,numfile_ts_K_vs_P,numfile_traj,numfile_cobweb_kinetic_energy,numfile_LEs_network_KP_space,numfile_LEs_Benettin_network,numfile_LEs_Benettin_numerical_diff,numfile_kinetic_nrg_derivative)

nmax=(tf-t0)/tstep	;	t=t0

ndof2=2*ndof

! for ndof=15 (degrees of freedom), the SPO1 is destabilized at the energy Ec=1.6069811732
min_number_of_nrg=1	;	max_number_of_nrg=1
allocate(array_nrg(min_number_of_nrg:max_number_of_nrg))
array_nrg(1)=nrg_input

! hamiltonianenergy=3.d0
!do i=min_number_of_nrg,max_number_of_nrg
! 	hamiltonianenergy=hamiltonianenergy+0.25d0
! 	array_nrg(i)=hamiltonianenergy
! 	write(*,*) i, array_nrg(i)
!enddo
!stop

call systemqq("mkdir -p results")

open(numfile_IcLE_and_maxdK_dt_vs_nrg,file='IcLE_and_maxdK_dt_vs_nrg.out.'//char_counternrg,status='replace')

nrg_loop: do j=min_number_of_nrg,max_number_of_nrg
	call cpu_time(time_begin)
	hamiltonianenergy=array_nrg(j)

	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	if ((0.d0<=hamiltonianenergy).and.(hamiltonianenergy<10.d0)) then
		write(char_nrg_1,'(f6.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_1)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_1)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_1)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
		endif
	endif
	if ((10.d0<=hamiltonianenergy).and.(hamiltonianenergy<100.d0)) then
		write(char_nrg_2,'(f7.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_2)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_2)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_2)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
		endif
	endif
	if ((100.d0<=hamiltonianenergy).and.(hamiltonianenergy<1000.d0)) then
		write(char_nrg_3,'(f8.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_3)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_3)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_3)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
		endif
	endif
	if ((1000.d0<=hamiltonianenergy).and.(hamiltonianenergy<10000.d0)) then
		write(char_nrg_4,'(f9.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_4)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_4)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_4)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
		endif
	endif
	if ((10000.d0<=hamiltonianenergy).and.(hamiltonianenergy<100000.d0)) then
		write(char_nrg_5,'(f10.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_5)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_5)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_ts_dK_dt_vs_K,file=file_name_output//'ts_dK_dt_vs_K_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_ts_K_vs_P,file=file_name_output//'ts_K_vs_P_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_traj,file=file_name_output//'trajectory_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			!open(numfile_cobweb_kinetic_energy,file=file_name_output//'cobweb_kinetic_energy_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_LEs_network_KP_space,file=file_name_output//'LEs_network_KP_space_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_LEs_Benettin_network,file=file_name_output//'LEs_Benettin_network_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_LEs_Benettin_numerical_diff,file=file_name_output//'LEs_Benettin_numerical_diff_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			open(numfile_kinetic_nrg_derivative,file=file_name_output//'kinetic_nrg_derivative_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_5)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
		endif
	endif
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	allocate(q((1+numberofdeviationvectors)*ndof2),q_neighbor_1(ndof2),q_neighbor_2(ndof2),q_difference(ndof2),qnorm(numberofdeviationvectors),suma(numberofdeviationvectors),LEs(numberofdeviationvectors))
	q=0.d0	;	q_neighbor_1=0.d0	;	q_neighbor_2=0.d0	;	q_difference=0.d0	;	qnorm=0.d0	;	suma=0.d0	;	LEs=0.d0

	allocate(vector_1(ndof2),vector_2(ndof2))
	vector_1=0.d0	;	vector_2=0.d0

	allocate(LE1_vector_embedding_kin_and_pot_nrg(2))
	LE1_vector_embedding_kin_and_pot_nrg=0.d0

	write(numfile_info,'(/,15x,"Lyapunov exponents for the FPU-beta FBC anharmonic oscillator lattice (SPO1)",/)')
	write(*,'(/,15x,"Lyapunov exponents for the FPU-beta FBC anharmonic oscillator lattice (SPO1)",/)')



	! definition of initial condition of the SPO1 is here
	solutionkappamodulus1=-(dSqrt(1 - dSqrt(1 + real(ndof,8))/dSqrt(1 + real(ndof,8) + 4*beta*hamiltonianenergy))/dSqrt(2.d0))
	solutionkappamodulus2=dSqrt(1 - dSqrt(1 + real(ndof,8))/dSqrt(1 + real(ndof,8) + 4*beta*hamiltonianenergy))/dSqrt(2.d0)
	solutionkappamodulus3=-(dSqrt(1 + dSqrt(1 + real(ndof,8))/dSqrt(1 + real(ndof,8) + 4*beta*hamiltonianenergy))/dSqrt(2.d0))
	solutionkappamodulus4=dSqrt(1 + dSqrt(1 + real(ndof,8))/dSqrt(1 + real(ndof,8) + 4*beta*hamiltonianenergy))/dSqrt(2.d0)
	if ((solutionkappamodulus1>=0.d0).and.(solutionkappamodulus1<=1.d0/dsqrt(2.d0))) then
		kappa_modulus2=solutionkappamodulus1**2
		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus1 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus1 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
	endif
	if ((solutionkappamodulus2>=0.d0).and.(solutionkappamodulus2<=1.d0/dsqrt(2.d0))) then
		kappa_modulus2=solutionkappamodulus2**2
		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus2 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus2 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
	endif
	if ((solutionkappamodulus3>=0.d0).and.(solutionkappamodulus3<=1.d0/dsqrt(2.d0))) then
		kappa_modulus2=solutionkappamodulus3**2
		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus3 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus3 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
	endif
	if ((solutionkappamodulus4>=0.d0).and.(solutionkappamodulus4<=1.d0/dsqrt(2.d0))) then
		kappa_modulus2=solutionkappamodulus4**2
		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus4 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus4 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
	endif
	c=(dSqrt(2.d0)*dSqrt(kappa_modulus2))/dSqrt(beta - 2*kappa_modulus2*beta)
	write(numfile_info,*)
	write(*,*)

	c_neighbor=c-perturbation
	do i=1,(ndof-1)/2
		q(2*i)=0.d0
	enddo
	do i=1,ndof,4
		q(i)=c_neighbor
	enddo
	do i=3,ndof,4
		q(i)=-c_neighbor
	enddo
	do i=1,ndof
		q(ndof+i)=0.d0
	enddo
	if (solved_hamiltonian_function((1+numberofdeviationvectors)*ndof2,q)>=0.d0) then
		q(ndof2)=dsqrt(solved_hamiltonian_function((1+numberofdeviationvectors)*ndof2,q))
	else
		write(*,'(1x,"q(",i2,")<0!")') ndof2
		write(numfile_info,'(1x,"q(",i2,")<0!")') ndof2
		stop
	endif
	! q(1:ndof2) is now the neighboring of the SPO1 initial condition and not the SPO anymore as it was just above
	! q(1:ndof2) is the reference orbit for which we compute the Lyapunov exponents using the variational equations		

	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	! here we write the trajectory for Ezequiel to compute the MIR
	write(numfile_traj,'(2f26.16)') q(1), q(ndof)
	call flush(numfile_traj)
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
	c_neighbor=c-2.d0*perturbation
	do i=1,(ndof-1)/2
		q_neighbor_1(2*i)=0.d0
	enddo
	do i=1,ndof,4
		q_neighbor_1(i)=c_neighbor
	enddo
	do i=3,ndof,4
		q_neighbor_1(i)=-c_neighbor
	enddo
	do i=1,ndof
		q_neighbor_1(ndof+i)=0.d0
	enddo
	if (solved_hamiltonian_function(ndof2,q_neighbor_1)>=0.d0) then
		q_neighbor_1(ndof2)=dsqrt(solved_hamiltonian_function(ndof2,q_neighbor_1))
	else
		write(*,'(1x,"q_neighbor_1(",i2,")<0!")') ndof2
		write(numfile_info,'(1x,"q_neighbor_1(",i2,")<0!")') ndof2
		stop
	endif
	! defined the q_neighbor_1(1:ndof2) initial condition
	! q_neighbor_1 is the first test orbit. We use it to compute the maximum Lyapunov exponent WITHOUT the use of the 
	! variational equations (Jacobian matrix of Hamilton's equations of motion)

	c_neighbor=c-3.d0*perturbation
	do i=1,(ndof-1)/2
		q_neighbor_2(2*i)=0.d0
	enddo
	do i=1,ndof,4
		q_neighbor_2(i)=c_neighbor
	enddo
	do i=3,ndof,4
		q_neighbor_2(i)=-c_neighbor
	enddo
	do i=1,ndof
		q_neighbor_2(ndof+i)=0.d0
	enddo
	if (solved_hamiltonian_function(ndof2,q_neighbor_2)>=0.d0) then
		q_neighbor_2(ndof2)=dsqrt(solved_hamiltonian_function(ndof2,q_neighbor_2))
	else
		write(*,'(1x,"q_neighbor_2(",i2,")<0!")') ndof2
		write(numfile_info,'(1x,"q_neighbor_2(",i2,")<0!")') ndof2
		stop
	endif
	! defined the q_neighbor_2(1:ndof2) initial condition
	! q_neighbor_2 is the second test orbit. We use it to compute the maximum Lyapunov exponent WITHOUT the use of the 
	! variational equations (Jacobian matrix of Hamilton's equations of motion)
	
	
	
	
	
	
	
	
	
	
	
		
		
		
! definition of initial condition of the SPO2 is here
!	solutionkappamodulus1=-(dsqrt((1.d0 + ndof + 6.d0*beta*hamiltonianenergy - dsqrt((1.d0 + ndof)*(1.d0 + ndof + 6.d0*beta*hamiltonianenergy)))/(1.d0 + ndof + 6.d0*beta*hamiltonianenergy))/dsqrt(2.d0))
!	solutionkappamodulus2=dsqrt((1.d0 + ndof + 6.d0*beta*hamiltonianenergy - dsqrt((1.d0 + ndof)*(1.d0 + ndof + 6.d0*beta*hamiltonianenergy)))/(1.d0 + ndof + 6.d0*beta*hamiltonianenergy))/dsqrt(2.d0)
!	solutionkappamodulus3=-(dsqrt((1.d0 + ndof + 6.d0*beta*hamiltonianenergy + dsqrt((1.d0 + ndof)*(1.d0 + ndof + 6.d0*beta*hamiltonianenergy)))/(1.d0 + ndof + 6.d0*beta*hamiltonianenergy))/dsqrt(2.d0))
!	solutionkappamodulus4=dsqrt((1.d0 + ndof + 6.d0*beta*hamiltonianenergy + dsqrt((1.d0 + ndof)*(1.d0 + ndof + 6.d0*beta*hamiltonianenergy)))/(1.d0 + ndof + 6.d0*beta*hamiltonianenergy))/dsqrt(2.d0)
!
!	if ((solutionkappamodulus1>=0.d0).and.(solutionkappamodulus1<=1.d0/dsqrt(2.d0))) then
!		kappa_modulus2=solutionkappamodulus1**2
!		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus1 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
!		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus1 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
!	endif
!	if ((solutionkappamodulus2>=0.d0).and.(solutionkappamodulus2<=1.d0/dsqrt(2.d0))) then
!		kappa_modulus2=solutionkappamodulus2**2
!		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus2 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
!		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus2 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
!	endif
!	if ((solutionkappamodulus3>=0.d0).and.(solutionkappamodulus3<=1.d0/dsqrt(2.d0))) then
!		kappa_modulus2=solutionkappamodulus3**2
!		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus3 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
!		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus3 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
!	endif
!	if ((solutionkappamodulus4>=0.d0).and.(solutionkappamodulus4<=1.d0/dsqrt(2.d0))) then
!		kappa_modulus2=solutionkappamodulus4**2
!		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus4 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
!		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus4 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
!	endif
!	c=(dsqrt(-1.d0 + 1.d0/(1.d0 - 2.d0*kappa_modulus2))/(dsqrt(3.d0)*dsqrt(beta)))
!	write(numfile_info,*)
!	write(*,*)
!
!	c_neighbor=c-perturbation
!	do i=2,ndof-3,3
!		q(i)=c_neighbor
!		q(i+3)=c_neighbor
!	enddo
!	do i=1,ndof-1,3
!		q(i)=c_neighbor
!		q(i+1)=-c_neighbor
!	enddo
!	do i=ndof+1,2*ndof
!		q(i)=0.d0
!	enddo
!	if (solved_hamiltonian_function((1+numberofdeviationvectors)*ndof2,q)>=0.d0) then
!		q(ndof2)=dsqrt(solved_hamiltonian_function((1+numberofdeviationvectors)*ndof2,q))
!	else
!		write(*,'(1x,"q(",i2,")<0!")') ndof2
!		write(numfile_info,'(1x,"q(",i2,")<0!")') ndof2
!		stop
!	endif
! q(1:ndof2) is now the neighboring of the SPO2 initial condition and not the SPO anymore as it was just above
! q(1:ndof2) is the reference orbit for which we compute the Lyapunov exponents using the variational equations
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! here we write the trajectory for Ezequiel to compute the MIR
!	write(numfile_traj,'(2f26.16)') q(1), q(ndof)
!	call flush(numfile_traj)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!		
!	c_neighbor=c-2.d0*perturbation
!	do i=2,ndof-3,3
!		q_neighbor_1(i)=c_neighbor
!		q_neighbor_1(i+3)=c_neighbor
!	enddo
!	do i=1,ndof-1,3
!		q_neighbor_1(i)=c_neighbor
!		q_neighbor_1(i+1)=-c_neighbor
!	enddo
!	do i=ndof+1,2*ndof
!		q_neighbor_1(i)=0.d0
!	enddo
!	if (solved_hamiltonian_function(ndof2,q_neighbor_1)>=0.d0) then
!		q_neighbor_1(ndof2)=dsqrt(solved_hamiltonian_function(ndof2,q_neighbor_1))
!	else
!		write(*,'(1x,"q_neighbor_1(",i2,")<0!")') ndof2
!		write(numfile_info,'(1x,"q_neighbor_1(",i2,")<0!")') ndof2
!		stop
!	endif
! defined the q_neighbor_1(1:ndof2) initial condition
! q_neighbor_1 is the first test orbit. We use it to compute the maximum Lyapunov exponent WITHOUT the use of the 
! variational equations (Jacobian matrix of Hamilton's equations of motion)
!
!	c_neighbor=c-3.d0*perturbation
!	do i=2,ndof-3,3
!		q_neighbor_2(i)=c_neighbor
!		q_neighbor_2(i+3)=c_neighbor
!	enddo
!	do i=1,ndof-1,3
!		q_neighbor_2(i)=c_neighbor
!		q_neighbor_2(i+1)=-c_neighbor
!	enddo
!	do i=ndof+1,2*ndof
!		q_neighbor_2(i)=0.d0
!	enddo
!	if (solved_hamiltonian_function(ndof2,q_neighbor_2)>=0.d0) then
!		q_neighbor_2(ndof2)=dsqrt(solved_hamiltonian_function(ndof2,q_neighbor_2))
!	else
!		write(*,'(1x,"q_neighbor_2(",i2,")<0!")') ndof2
!		write(numfile_info,'(1x,"q_neighbor_2(",i2,")<0!")') ndof2
!		stop
!	endif
! defined the q_neighbor_2(1:ndof2) initial condition
! q_neighbor_2 is the second test orbit. We use it to compute the maximum Lyapunov exponent WITHOUT the use of the 
! variational equations (Jacobian matrix of Hamilton's equations of motion)

	do i=1,ndof2
		write(*,'(" q(",i3,")= ",f22.12,", q_neighbor_1(",i3,")=",f22.12,", q_neighbor_2(",i3,")=",f22.12)') i, q(i), i, q_neighbor_1(i), i, q_neighbor_2(i)
		write(numfile_info,'(" q(",i3,")= ",f22.12,", q_neighbor_1(",i3,")=",f22.12,", q_neighbor_2(",i3,")=",f22.12)') i, q(i), i, q_neighbor_1(i), i, q_neighbor_2(i)
	enddo

vector_1(1:ndof2)=q(1:ndof2)-q_neighbor_1(1:ndof2)
vector_2(1:ndof2)=q(1:ndof2)-q_neighbor_2(1:ndof2)

	write(*,*)
	write(numfile_info,*)
	do i=1,ndof2
		write(*,'(" q(",i3,")= ",f22.12,", q_neighbor_1(",i3,")=",f22.12,", q_neighbor_2(",i3,")=",f22.12)') i, q(i), i, q_neighbor_1(i), i, q_neighbor_2(i)
		write(numfile_info,'(" q(",i3,")= ",f22.12,", q_neighbor_1(",i3,")=",f22.12,", q_neighbor_2(",i3,")=",f22.12)') i, q(i), i, q_neighbor_1(i), i, q_neighbor_2(i)
	enddo

	call Hamiltonian_function((1+numberofdeviationvectors)*ndof2,q,hamiltonianenergy_q)
	write(*,'(" Hamiltonian energy of initial condition q=",f26.16)') hamiltonianenergy_q
	write(numfile_info,'(" Hamiltonian energy of initial condition q=",f26.16)') hamiltonianenergy_q

	call Hamiltonian_function(ndof2,q_neighbor_1,hamiltonianenergy_q_neighbor_1)
	write(*,'(" Hamiltonian energy of initial condition q_neighbor_1=",f26.16)') hamiltonianenergy_q_neighbor_1
	write(numfile_info,'(" Hamiltonian energy of initial condition q_neighbor_1=",f26.16)') hamiltonianenergy_q_neighbor_1

	call Hamiltonian_function(ndof2,q_neighbor_2,hamiltonianenergy_q_neighbor_2)
	write(*,'(" Hamiltonian energy of initial condition q_neighbor_2=",f26.16,/)') hamiltonianenergy_q_neighbor_2
	write(numfile_info,'(" Hamiltonian energy of initial condition q_neighbor_2=",f26.16,/)') hamiltonianenergy_q_neighbor_2

	initial_distance_LE1_network=dsqrt(dot_product(vector_1(1:ndof2),vector_1(1:ndof2)))
	initial_distance_LE2_network=dsqrt(dot_product(vector_2(1:ndof2),vector_2(1:ndof2)))

	initial_distance_LE1_embedding_kin_and_pot_nrg=dsqrt((kinetic_energy_function(q,ndof2)-kinetic_energy_function(q_neighbor_1,ndof2))**2+(potential_energy_function(q,ndof2)-potential_energy_function(q_neighbor_1,ndof2))**2)
	initial_distance_LE2_embedding_kin_and_pot_nrg=dsqrt((kinetic_energy_function(q,ndof2)-kinetic_energy_function(q_neighbor_2,ndof2))**2+(potential_energy_function(q,ndof2)-potential_energy_function(q_neighbor_2,ndof2))**2)

	relative_energy_error=dabs(hamiltonianenergy-hamiltonianenergy_q)/hamiltonianenergy

	! initial conditions for the deviation vectors according to the usual orthonormal basis of R^N
	do index=1,numberofdeviationvectors
		q(index*(ndof2+1))=1.d0
	enddo

	write(numfile_info,'(" Number of degrees of freedom= ",i8)') ndof
	write(numfile_info,'(" Order of symplectic integrator= ",i1)') si
	write(numfile_info,'(" Initial time= ",f26.16)') t0
	write(numfile_info,'(" Final time= ",es26.16)') tf
	write(numfile_info,'(" Time step of the symplectic integrator= ",es26.16)') tstep
	write(numfile_info,'(" Number of time units= ",es26.16)') nmax
	write(numfile_info,'(" Hamiltonian energy= ",f26.16)') hamiltonianenergy
	write(numfile_info,'(" Energy density= ",f26.16)') hamiltonianenergy/ndof
	write(numfile_info,'(" beta= ",f26.16)') beta
	write(numfile_info,'(" Number of deviation vectors= ",i5)') numberofdeviationvectors
	write(numfile_info,'(" Perturbation of the initial conditions= ",es26.16)') perturbation
	write(numfile_info,'(" For t=",1x,es26.16,1x,"the Euclidean distance of q-q_neighbor_1 vector=",1x,es26.16)') t0, initial_distance_LE1_network
	write(numfile_info,'(" For t=",1x,es26.16,1x,"the Euclidean distance of q-q_neighbor_2 vector=",1x,es26.16)') t0, initial_distance_LE2_network
	write(numfile_info,'(" For t=",1x,es26.16,1x,"the dot product of (q-q_neighbor_1) and (q-q_neighbor_2) vectors=",1x,es26.16)') t0, dot_product(vector_1,vector_2)
	write(numfile_rel_ham_err,'(/,"Current time/ Final time",9x,"Computed energy",7x,"Relative energy error")')
	write(numfile_rel_ham_err,'(es11.4," /",es11.4,f26.16,9x,es11.4)') t, tf, hamiltonianenergy, relative_energy_error

	write(*,'(" Number of degrees of freedom= ",i8)') ndof
	write(*,'(" Order of symplectic integrator= ",i1)') si
	write(*,'(" Initial time= ",f26.16)') t0
	write(*,'(" Final time= ",es26.16)') tf
	write(*,'(" Time step of the symplectic integrator= ",es26.16)') tstep
	write(*,'(" Number of time units= ",es26.16)') nmax
	write(*,'(" Hamiltonian energy= ",f26.16)') hamiltonianenergy
	write(*,'(" Energy density= ",f26.16)') hamiltonianenergy/ndof
	write(*,'(" beta= ",f26.16)') beta
	write(*,'(" Number of deviation vectors= ",i5)') numberofdeviationvectors
	write(*,'(" Perturbation of the initial conditions= ",es26.16)') perturbation
	write(*,'(" For t=",1x,es26.16,1x,"the Euclidean distance of q-q_neighbor_1 vector=",1x,es26.16)') t0, initial_distance_LE1_network
	write(*,'(" For t=",1x,es26.16,1x,"the Euclidean distance of q-q_neighbor_2 vector=",1x,es26.16)') t0, initial_distance_LE2_network
	write(*,'(" For t=",1x,es26.16,1x,"the dot product of (q-q_neighbor_1) and (q-q_neighbor_2) vectors=",1x,es26.16)') t0, dot_product(vector_1,vector_2)
	write(*,'(/,"Current time/ Final time",9x,"Computed energy",7x,"Relative energy error")')
	write(*,'(es11.4," /",es11.4,f26.16,9x,es11.4)') t, tf, hamiltonianenergy, relative_energy_error

LE1_vector_embedding_kin_and_pot_nrg(1)=kinetic_energy_function(q,ndof2)-kinetic_energy_function(q_neighbor_1,ndof2)
LE1_vector_embedding_kin_and_pot_nrg(2)=potential_energy_function(q,ndof2)-potential_energy_function(q_neighbor_1,ndof2)

in_dist=dsqrt(dot_product(LE1_vector_embedding_kin_and_pot_nrg,LE1_vector_embedding_kin_and_pot_nrg))

	ii=0.d0	;	multiple=0

	sum_LE1_network=0.d0
	sum_LE2_network=0.d0
	sum_LE1_embedding_kin_and_pot_nrg=0.d0
	sum_LE2_embedding_kin_and_pot_nrg=0.d0

	sum_time_average_abs_dk_over_LE1_Ham_vs_nrg=0.d0
	sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg=0.d0
	sum_time_average_Tq1=0.d0

	sum_LE1=0.d0
	maxdK_dt=-huge(1.d0)

	do while (ii<nmax)
		kinetic_energy_old=kinetic_energy_function(q,ndof2)
		potential_energy_old=potential_energy_function(q,ndof2)
		Tq1_old=Tq1(q,ndof2)

		select case (si)
		case(1)
			call si_mapping_1st_order(ndof2,numberofdeviationvectors,q,tstep)
			call si_mapping_1st_order(ndof2,0,q_neighbor_1,tstep)
			call si_mapping_1st_order(ndof2,0,q_neighbor_2,tstep)
		case(2)
			call si_mapping_2nd_order(ndof2,numberofdeviationvectors,q,tstep)
			call si_mapping_2nd_order(ndof2,0,q_neighbor_1,tstep)
			call si_mapping_2nd_order(ndof2,0,q_neighbor_2,tstep)
		case(3)
			call si_mapping_3rd_order(ndof2,numberofdeviationvectors,q,tstep)
			call si_mapping_3rd_order(ndof2,0,q_neighbor_1,tstep)
			call si_mapping_3rd_order(ndof2,0,q_neighbor_2,tstep)
		case(4)
			call si_mapping_4th_order(ndof2,numberofdeviationvectors,q,tstep)
			call si_mapping_4th_order(ndof2,0,q_neighbor_1,tstep)
			call si_mapping_4th_order(ndof2,0,q_neighbor_2,tstep)
		case(6)
			call si_mapping_6th_order(ndof2,numberofdeviationvectors,q,tstep)
			call si_mapping_6th_order(ndof2,0,q_neighbor_1,tstep)
			call si_mapping_6th_order(ndof2,0,q_neighbor_2,tstep)
		case(8)
			call si_mapping_8th_order(ndof2,numberofdeviationvectors,q,tstep)
			call si_mapping_8th_order(ndof2,0,q_neighbor_1,tstep)
			call si_mapping_8th_order(ndof2,0,q_neighbor_2,tstep)
		case default
			write(*,'(/,/," Wrong number for the order of the symplectic integrator",/,/)')
			write(*,'(" It should be either 1, 2, 3, 4, 6 or 8.",/,/)')
			write(numfile_info,'(/,/," Wrong number for the order of the symplectic integrator",/,/)')
			write(numfile_info,'(" It should be either 1, 2, 3, 4, 6 or 8.",/,/)')
			stop
		end select

		ii=ii+1.d0
		t=t0+ii*tstep

		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		! here we write the trajectory for Ezequiel to compute the MIR
		if (dmod(ii,100.d0)==0.d0) then
			write(numfile_traj,'(2f26.16)') q(1), q(ndof)
			call flush(numfile_traj)
		endif
		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		! computation of the maximum Lyapunov exponent (LE1) of the whole network (of the phase space of the ndof2 dimensions)
vector_1(1:ndof2)=q(1:ndof2)-q_neighbor_1(1:ndof2)
vector_2(1:ndof2)=q(1:ndof2)-q_neighbor_2(1:ndof2)

call Gram_Schmidt_orthogonalization_2_vectors(ndof2,vector_1,vector_2)
q_neighbor_2(1:ndof2)=q(1:ndof2)-vector_2(1:ndof2)

current_distance_LE1_network=dsqrt(dot_product(vector_1(1:ndof2),vector_1(1:ndof2)))
alpha_LE1_network=current_distance_LE1_network/initial_distance_LE1_network
sum_LE1_network=sum_LE1_network+dlog(alpha_LE1_network)
LE1_network=sum_LE1_network/t

current_distance_LE2_network=dsqrt(dot_product(vector_2(1:ndof2),vector_2(1:ndof2)))
alpha_LE2_network=current_distance_LE2_network/initial_distance_LE2_network
sum_LE2_network=sum_LE2_network+dlog(alpha_LE2_network)
LE2_network=sum_LE2_network/t

! computation of the maximum Lyapunov exponent (LE1) of the embedding plane (K,P) where
! K=Kinetic energy
! P=Potential energy
! and K + P=hamiltonianenergy
current_distance_LE1_embedding_kin_and_pot_nrg=dsqrt((kinetic_energy_function(q,ndof2)-kinetic_energy_function(q_neighbor_1,ndof2))**2+(potential_energy_function(q,ndof2)-potential_energy_function(q_neighbor_1,ndof2))**2)
alpha_LE1_embedding_kin_and_pot_nrg=current_distance_LE1_embedding_kin_and_pot_nrg/initial_distance_LE1_embedding_kin_and_pot_nrg
sum_LE1_embedding_kin_and_pot_nrg=sum_LE1_embedding_kin_and_pot_nrg+dlog(alpha_LE1_embedding_kin_and_pot_nrg)
LE1_embedding_kin_and_pot_nrg=sum_LE1_embedding_kin_and_pot_nrg/t

! computation of the second maximum Lyapunov exponent (LE2) of the embedding plane (K,P) where
! K=Kinetic energy
! P=Potential energy
! and K + P=hamiltonianenergy
current_distance_LE2_embedding_kin_and_pot_nrg=dsqrt((kinetic_energy_function(q,ndof2)-kinetic_energy_function(q_neighbor_2,ndof2))**2+(potential_energy_function(q,ndof2)-potential_energy_function(q_neighbor_2,ndof2))**2)
alpha_LE2_embedding_kin_and_pot_nrg=current_distance_LE2_embedding_kin_and_pot_nrg/initial_distance_LE2_embedding_kin_and_pot_nrg
sum_LE2_embedding_kin_and_pot_nrg=sum_LE2_embedding_kin_and_pot_nrg+dlog(alpha_LE2_embedding_kin_and_pot_nrg)
LE2_embedding_kin_and_pot_nrg=sum_LE2_embedding_kin_and_pot_nrg/t

LE1_vector_embedding_kin_and_pot_nrg(1)=kinetic_energy_function(q,ndof2)-kinetic_energy_function(q_neighbor_1,ndof2)
LE1_vector_embedding_kin_and_pot_nrg(2)=potential_energy_function(q,ndof2)-potential_energy_function(q_neighbor_1,ndof2)

cur_dist=dsqrt(dot_product(LE1_vector_embedding_kin_and_pot_nrg,LE1_vector_embedding_kin_and_pot_nrg))

alpha=cur_dist/in_dist
sum_LE1=sum_LE1+dlog(alpha)
LE1=sum_LE1/t

		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! normalization of the stretching or contracting distance between the current point of the reference orbit q and 
! the test orbit q_neighbor_1
q_difference(1:ndof2)=-vector_1(1:ndof2)
q_neighbor_1(1:ndof2)=q(1:ndof2)+(q_difference(1:ndof2)/alpha_LE1_network)

! normalization of the stretching or contracting distance between the current point of the reference orbit q and 
! the test orbit q_neighbor_2
q_difference(1:ndof2)=-vector_2(1:ndof2)
q_neighbor_2(1:ndof2)=q(1:ndof2)+(q_difference(1:ndof2)/alpha_LE2_network)

vector_1(1:ndof2)=q(1:ndof2)-q_neighbor_1(1:ndof2)
vector_2(1:ndof2)=q(1:ndof2)-q_neighbor_2(1:ndof2)

initial_distance_LE1_network=dsqrt(dot_product(vector_1(1:ndof2),vector_1(1:ndof2)))
initial_distance_LE2_network=dsqrt(dot_product(vector_2(1:ndof2),vector_2(1:ndof2)))

initial_distance_LE1_embedding_kin_and_pot_nrg=dsqrt((kinetic_energy_function(q,ndof2)-kinetic_energy_function(q_neighbor_1,ndof2))**2+(potential_energy_function(q,ndof2)-potential_energy_function(q_neighbor_1,ndof2))**2)
initial_distance_LE2_embedding_kin_and_pot_nrg=dsqrt((kinetic_energy_function(q,ndof2)-kinetic_energy_function(q_neighbor_2,ndof2))**2+(potential_energy_function(q,ndof2)-potential_energy_function(q_neighbor_2,ndof2))**2)

LE1_vector_embedding_kin_and_pot_nrg(1)=kinetic_energy_function(q,ndof2)-kinetic_energy_function(q_neighbor_1,ndof2)
LE1_vector_embedding_kin_and_pot_nrg(2)=potential_energy_function(q,ndof2)-potential_energy_function(q_neighbor_1,ndof2)

in_dist=dsqrt(dot_product(LE1_vector_embedding_kin_and_pot_nrg,LE1_vector_embedding_kin_and_pot_nrg))

! cobweb plot for Kinetic energy
!if (ii==1.d0) then
!	write(numfile_cobweb_kinetic_energy,'(2f26.16)') kinetic_energy_old, 0.d0
!	write(numfile_cobweb_kinetic_energy,'(2f26.16)') kinetic_energy_old, kinetic_energy_function(q,ndof2)
!else
!	write(numfile_cobweb_kinetic_energy,'(2f26.16)') kinetic_energy_old, kinetic_energy_old
!	write(numfile_cobweb_kinetic_energy,'(2f26.16)') kinetic_energy_old, kinetic_energy_function(q,ndof2)
!endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		dK_dt=kinetic_energy_derivative_function(q,ndof2)
		if (dK_dt>maxdK_dt) maxdK_dt=dK_dt
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		sum_time_average_abs_dk_over_LE1_Ham_vs_nrg=sum_time_average_abs_dk_over_LE1_Ham_vs_nrg+dabs(kinetic_energy_function(q,ndof2)-kinetic_energy_old)
		sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg=sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg+dabs(dK_dt)
		sum_time_average_Tq1=sum_time_average_Tq1+dabs(Tq1(q,ndof2)-Tq1_old)

		call Gram_Schmidt_orthogonormalization(ndof2,numberofdeviationvectors,q,qnorm)
		call Lyapunov_exponents(numberofdeviationvectors,qnorm,suma,t,LEs)

		if (dabs(t-10.d0**(1.d0+multiple*.05d0))<=tstep.or.t>=tf) then
			call Hamiltonian_function((1+numberofdeviationvectors)*ndof2,q,hamiltonianenergy_q)
			relative_energy_error=dabs(hamiltonianenergy-hamiltonianenergy_q)/hamiltonianenergy
			write(*,'(es11.4," /",es11.4,f26.16,9x,es11.4)') t, tf, hamiltonianenergy_q, relative_energy_error
			write(numfile_rel_ham_err,'(es11.4," /",es11.4,f26.16,9x,es11.4)') t, tf, hamiltonianenergy_q, relative_energy_error
			call flush(numfile_rel_ham_err)
			if (numberofdeviationvectors==ndof2) then
				write(numfile_Lyap_exps,'(es26.16,<numberofdeviationvectors>f26.16,es26.16)') t, (LEs(index),index=1,numberofdeviationvectors), dabs(sum(LEs))
				call flush(numfile_Lyap_exps)
			else
				write(numfile_Lyap_exps,'(es26.16,<numberofdeviationvectors>f26.16,f26.16)') t, (LEs(index),index=1,numberofdeviationvectors), sum(LEs(1:numberofdeviationvectors))
				call flush(numfile_Lyap_exps)
			endif

call Hamiltonian_function((1+numberofdeviationvectors)*ndof2,q,hamiltonianenergy_q)
call Hamiltonian_function(ndof2,q_neighbor_1,hamiltonianenergy_q_neighbor_1)
call Hamiltonian_function(ndof2,q_neighbor_2,hamiltonianenergy_q_neighbor_2)

write(numfile_LEs_network_KP_space,'(5f26.16,3es26.16)') t, LE1_network, LE2_network, LE1_embedding_kin_and_pot_nrg, LE2_embedding_kin_and_pot_nrg, dabs(hamiltonianenergy_q-hamiltonianenergy), dabs(hamiltonianenergy_q_neighbor_1-hamiltonianenergy), dabs(hamiltonianenergy_q_neighbor_2-hamiltonianenergy)
call flush(numfile_LEs_network_KP_space)

write(numfile_LEs_Benettin_network,'(f26.16,4es26.16)') t, dabs(LEs(1)-LE1_network), dabs(LEs(2)-LE2_network), dabs(LEs(1)-LE1_embedding_kin_and_pot_nrg), dabs(LEs(2)-LE2_embedding_kin_and_pot_nrg)
call flush(numfile_LEs_Benettin_network)

write(numfile_LEs_Benettin_numerical_diff,'(2f26.16,es26.16)') t, LE1, dabs(LEs(1)-LE1)
call flush(numfile_LEs_Benettin_numerical_diff)

			multiple=multiple+1
		endif
		if (0.95d0*tf<=t.and.t<=tf) then
			write(numfile_ts_dK_dt_vs_K,'(2f26.16)') kinetic_energy_function(q,ndof2), kinetic_energy_derivative_function(q,ndof2)
			write(numfile_ts_K_vs_P,'(2f26.16)') kinetic_energy_function(q,ndof2), potential_energy_function(q,ndof2)
		endif

		if (dabs(kinetic_energy_function(q,ndof2)-hamiltonianenergy/2.d0)<0.0001d0) then
			write(numfile_kinetic_nrg_derivative,'(3f26.16)') t, kinetic_energy_function(q,ndof2), kinetic_energy_derivative_function(q,ndof2)
			call flush(numfile_kinetic_nrg_derivative)
		endif
 	enddo ! end of time loop

	close(numfile_rel_ham_err)
	close(numfile_Lyap_exps)
	close(numfile_ts_dK_dt_vs_K)
	close(numfile_ts_K_vs_P)
	close(numfile_traj)

	sum_time_average_abs_dk_over_LE1_Ham_vs_nrg=sum_time_average_abs_dk_over_LE1_Ham_vs_nrg/t
	sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg=sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg/t
	sum_time_average_Tq1=sum_time_average_Tq1/t

	IcLE=2.d0*sum(LEs(1:int(numberofdeviationvectors/2)))-sum(LEs(1:numberofdeviationvectors))
	H_KS_entropy=sum(LEs(1:numberofdeviationvectors))
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	write(numfile_IcLE_and_maxdK_dt_vs_nrg,'(es26.16,9f26.16,i4)') t, hamiltonianenergy, maxdK_dt, IcLE, H_KS_entropy, sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg/LEs(1), sum_time_average_abs_dk_over_LE1_Ham_vs_nrg/LEs(1), LEs(1), LEs(1)-LEs(2), sum_time_average_Tq1, counternrg
	call flush(numfile_IcLE_and_maxdK_dt_vs_nrg)
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	deallocate(q,q_neighbor_1,q_neighbor_2,q_difference,qnorm,suma,LEs)
	deallocate(vector_1,vector_2)
	deallocate(LE1_vector_embedding_kin_and_pot_nrg)

	call write_used_time(numfile_info,time_begin)
	close(numfile_info)
	close(numfile_cobweb_kinetic_energy)
	close(numfile_LEs_network_KP_space)
	close(numfile_LEs_Benettin_network)
	close(numfile_LEs_Benettin_numerical_diff)
	close(numfile_kinetic_nrg_derivative)
	close(numfile_IcLE_and_maxdK_dt_vs_nrg)

	if ((0.d0<=hamiltonianenergy).and.(hamiltonianenergy<10.d0)) then
		write(char_nrg_1,'(f6.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_1//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'trajectory_"//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_1//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_1//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'trajectory_"//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_1//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")

			endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_1//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'trajectory_"//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_1//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
	endif
	if ((10.d0<=hamiltonianenergy).and.(hamiltonianenergy<100.d0)) then
		write(char_nrg_2,'(f7.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_2//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'trajectory_"//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_2//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_2//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'trajectory_"//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_2//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_2//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'trajectory_"//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_2//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
	endif
	if ((100.d0<=hamiltonianenergy).and.(hamiltonianenergy<1000.d0)) then
		write(char_nrg_3,'(f8.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_3//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'trajectory_"//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_3//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_3//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'trajectory_"//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_3//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_3//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'trajectory_"//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_3//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
	endif
	if ((1000.d0<=hamiltonianenergy).and.(hamiltonianenergy<10000.d0)) then
		write(char_nrg_4,'(f9.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_4//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'trajectory_"//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
			call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_4//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_4//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'trajectory_"//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
			call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_4//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_4//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'trajectory_"//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
			call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_4//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
	endif
	if ((10000.d0<=hamiltonianenergy).and.(hamiltonianenergy<100000.d0)) then
		write(char_nrg_5,'(f10.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_5//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'trajectory_"//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
			call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_5//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_5//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'trajectory_"//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
			call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_5//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_5//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'ts_dK_dt_vs_K_"//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'ts_K_vs_P_"//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'trajectory_"//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			!call systemqq("mv 'cobweb_kinetic_energy_"//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_network_KP_space_"//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_Benettin_network_"//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'LEs_Benettin_numerical_diff_"//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("mv 'kinetic_nrg_derivative_"//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
			call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
			call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_5//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
	endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!	call IcLE_and_maxdK_dt_vs_nrg_plot_gnu_file(numfile_IcLE_and_maxdK_dt_vs_nrg_gnu)
!	call systemqq("gnuplot < IcLE_and_maxdK_dt_vs_nrg_plot.gnu")
enddo nrg_loop

!call systemqq("gnuplot < IcLE_and_maxdK_dt_vs_nrg_plot.gnu")
!call systemqq("mv IcLE_and_maxdK_dt_vs_nrg*.* 'results/'")

deallocate(array_nrg)

end program FPUb_LEs_si_Yoshida
