!**********************************************************************
function Tq1(q,n)
implicit none
integer(kind=4),intent(in) :: n
real(kind=8),intent(in) :: q(n)
real(kind=8) :: Tq1

Tq1=q(16)**2/2.

return
end function Tq1

!**********************************************************************
subroutine Hamiltonian_function(n,q,hamiltonian_energy)
implicit none
integer(kind=4),intent(in) :: n
real(kind=8),intent(in) :: q(n)
real(kind=8),intent(out) :: hamiltonian_energy
real(kind=8) :: beta
common /param1/ beta

hamiltonian_energy=(q(1)**2 + (-q(1) + q(2))**2 + (-q(2) + q(3))**2 + (-q(3) + q(4))**2 + (-q(4) + q(5))**2 + (-q(5) + q(6))**2 + (-q(6) + q(7))**2 + (-q(7) + q(8))**2 + (-q(8) + q(9))**2 + (-q(9) + q(10))**2 + (-q(10) + q(11))**2 + (-q(11) + q(12))**2 + (-q(12) + q(13))**2 + (-q(13) + q(14))**2 + q(15)**2 + (-q(14) + q(15))**2)/2. + (beta*(q(1)**4 + (-q(1) + q(2))**4 + (-q(2) + q(3))**4 + (-q(3) + q(4))**4 + (-q(4) + q(5))**4 + (-q(5) + q(6))**4 + (-q(6) + q(7))**4 + (-q(7) + q(8))**4 + (-q(8) + q(9))**4 + (-q(9) + q(10))**4 + (-q(10) + q(11))**4 + (-q(11) + q(12))**4 + (-q(12) + q(13))**4 + (-q(13) + q(14))**4 + q(15)**4 + (-q(14) + q(15))**4))/4. + (q(16)**2 + q(17)**2 + q(18)**2 + q(19)**2 + q(20)**2 + q(21)**2 + q(22)**2 + q(23)**2 + q(24)**2 + q(25)**2 + q(26)**2 + q(27)**2 + q(28)**2 + q(29)**2 + q(30)**2)/2.

return
end subroutine Hamiltonian_function

!**********************************************************************

function solved_hamiltonian_function(n,q)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: beta, hamiltonianenergy, solved_hamiltonian_function
common /param1/ beta
common /param2/ hamiltonianenergy

solved_hamiltonian_function= 2*hamiltonianenergy - 2*q(1)**2 - beta*q(1)**4 + 2*q(1)*q(2) + 2*beta*q(1)**3*q(2) - 2*q(2)**2 - 3*beta*q(1)**2*q(2)**2 + 2*beta*q(1)*q(2)**3 - beta*q(2)**4 + 2*q(2)*q(3) + 2*beta*q(2)**3*q(3) - 2*q(3)**2 - 3*beta*q(2)**2*q(3)**2 + 2*beta*q(2)*q(3)**3 - beta*q(3)**4 + 2*q(3)*q(4) + 2*beta*q(3)**3*q(4) - 2*q(4)**2 - 3*beta*q(3)**2*q(4)**2 + 2*beta*q(3)*q(4)**3 - beta*q(4)**4 + 2*q(4)*q(5) + 2*beta*q(4)**3*q(5) - 2*q(5)**2 - 3*beta*q(4)**2*q(5)**2 + 2*beta*q(4)*q(5)**3 - beta*q(5)**4 + 2*q(5)*q(6) + 2*beta*q(5)**3*q(6) - 2*q(6)**2 - 3*beta*q(5)**2*q(6)**2 + 2*beta*q(5)*q(6)**3 - beta*q(6)**4 + 2*q(6)*q(7) + 2*beta*q(6)**3*q(7) - 2*q(7)**2 - 3*beta*q(6)**2*q(7)**2 + 2*beta*q(6)*q(7)**3 - beta*q(7)**4 + 2*q(7)*q(8) + 2*beta*q(7)**3*q(8) - 2*q(8)**2 - 3*beta*q(7)**2*q(8)**2 + 2*beta*q(7)*q(8)**3 - beta*q(8)**4 + 2*q(8)*q(9) + 2*beta*q(8)**3*q(9) - 2*q(9)**2 - 3*beta*q(8)**2*q(9)**2 + 2*beta*q(8)*q(9)**3 - beta*q(9)**4 + 2*q(9)*q(10) + 2*beta*q(9)**3*q(10) - 2*q(10)**2 - 3*beta*q(9)**2*q(10)**2 + 2*beta*q(9)*q(10)**3 - beta*q(10)**4 + 2*q(10)*q(11) + 2*beta*q(10)**3*q(11) - 2*q(11)**2 - 3*beta*q(10)**2*q(11)**2 + 2*beta*q(10)*q(11)**3 - beta*q(11)**4 + 2*q(11)*q(12) + 2*beta*q(11)**3*q(12) - 2*q(12)**2 - 3*beta*q(11)**2*q(12)**2 + 2*beta*q(11)*q(12)**3 - beta*q(12)**4 + 2*q(12)*q(13) + 2*beta*q(12)**3*q(13) - 2*q(13)**2 - 3*beta*q(12)**2*q(13)**2 + 2*beta*q(12)*q(13)**3 - beta*q(13)**4 + 2*q(13)*q(14) + 2*beta*q(13)**3*q(14) - 2*q(14)**2 - 3*beta*q(13)**2*q(14)**2 + 2*beta*q(13)*q(14)**3 - beta*q(14)**4 + 2*q(14)*q(15) + 2*beta*q(14)**3*q(15) - 2*q(15)**2 - 3*beta*q(14)**2*q(15)**2 + 2*beta*q(14)*q(15)**3 - beta*q(15)**4 - q(16)**2 - q(17)**2 - q(18)**2 - q(19)**2 - q(20)**2 - q(21)**2 - q(22)**2 - q(23)**2 - q(24)**2 - q(25)**2 - q(26)**2 - q(27)**2 - q(28)**2 - q(29)**2

return
end function solved_hamiltonian_function

!**********************************************************************

subroutine TDH_function(n,q,numberofdeviationvectors,index,TDH_energy)
implicit none
integer(kind=4),intent(in) :: n, numberofdeviationvectors, index
real(kind=8),intent(in) :: q(n)
real(kind=8),intent(out) :: TDH_energy(numberofdeviationvectors)
real(kind=8) :: beta
common /param1/ beta

TDH_energy(index)=((2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index)**2 + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(1 + 30*index)*q(2 + 30*index) + (2 + (beta*(12*(-q(1) + q(2))**2 + 12*(-q(2) + q(3))**2))/4.)*q(2 + 30*index)**2 + 2*(-1 - 3*beta*(-q(2) + q(3))**2)*q(2 + 30*index)*q(3 + 30*index) + (2 + (beta*(12*(-q(2) + q(3))**2 + 12*(-q(3) + q(4))**2))/4.)*q(3 + 30*index)**2 + 2*(-1 - 3*beta*(-q(3) + q(4))**2)*q(3 + 30*index)*q(4 + 30*index) + (2 + (beta*(12*(-q(3) + q(4))**2 + 12*(-q(4) + q(5))**2))/4.)*q(4 + 30*index)**2 + 2*(-1 - 3*beta*(-q(4) + q(5))**2)*q(4 + 30*index)*q(5 + 30*index) + (2 + (beta*(12*(-q(4) + q(5))**2 + 12*(-q(5) + q(6))**2))/4.)*q(5 + 30*index)**2 + 2*(-1 - 3*beta*(-q(5) + q(6))**2)*q(5 + 30*index)*q(6 + 30*index) + (2 + (beta*(12*(-q(5) + q(6))**2 + 12*(-q(6) + q(7))**2))/4.)*q(6 + 30*index)**2 + 2*(-1 - 3*beta*(-q(6) + q(7))**2)*q(6 + 30*index)*q(7 + 30*index) + (2 + (beta*(12*(-q(6) + q(7))**2 + 12*(-q(7) + q(8))**2))/4.)*q(7 + 30*index)**2 + 2*(-1 - 3*beta*(-q(7) + q(8))**2)*q(7 + 30*index)*q(8 + 30*index) + (2 + (beta*(12*(-q(7) + q(8))**2 + 12*(-q(8) + q(9))**2))/4.)*q(8 + 30*index)**2 + 2*(-1 - 3*beta*(-q(8) + q(9))**2)*q(8 + 30*index)*q(9 + 30*index) + (2 + (beta*(12*(-q(8) + q(9))**2 + 12*(-q(9) + q(10))**2))/4.)*q(9 + 30*index)**2 + 2*(-1 - 3*beta*(-q(9) + q(10))**2)*q(9 + 30*index)*q(10 + 30*index) + (2 + (beta*(12*(-q(9) + q(10))**2 + 12*(-q(10) + q(11))**2))/4.)*q(10 + 30*index)**2 + 2*(-1 - 3*beta*(-q(10) + q(11))**2)*q(10 + 30*index)*q(11 + 30*index) + (2 + (beta*(12*(-q(10) + q(11))**2 + 12*(-q(11) + q(12))**2))/4.)*q(11 + 30*index)**2 + 2*(-1 - 3*beta*(-q(11) + q(12))**2)*q(11 + 30*index)*q(12 + 30*index) + (2 + (beta*(12*(-q(11) + q(12))**2 + 12*(-q(12) + q(13))**2))/4.)*q(12 + 30*index)**2 + 2*(-1 - 3*beta*(-q(12) + q(13))**2)*q(12 + 30*index)*q(13 + 30*index) + (2 + (beta*(12*(-q(12) + q(13))**2 + 12*(-q(13) + q(14))**2))/4.)*q(13 + 30*index)**2 + 2*(-1 - 3*beta*(-q(13) + q(14))**2)*q(13 + 30*index)*q(14 + 30*index) + (2 + (beta*(12*(-q(13) + q(14))**2 + 12*(-q(14) + q(15))**2))/4.)*q(14 + 30*index)**2 + 2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index)*q(15 + 30*index) + (2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)**2)/2. + (q(1 + 15*(1 + 2*index))**2 + q(2 + 15*(1 + 2*index))**2 + q(3 + 15*(1 + 2*index))**2 + q(4 + 15*(1 + 2*index))**2 + q(5 + 15*(1 + 2*index))**2 + q(6 + 15*(1 + 2*index))**2 + q(7 + 15*(1 + 2*index))**2 + q(8 + 15*(1 + 2*index))**2 + q(9 + 15*(1 + 2*index))**2 + q(10 + 15*(1 + 2*index))**2 + q(11 + 15*(1 + 2*index))**2 + q(12 + 15*(1 + 2*index))**2 + q(13 + 15*(1 + 2*index))**2 + q(14 + 15*(1 + 2*index))**2 + q(15 + 15*(1 + 2*index))**2)/2.

return
end subroutine TDH_function

!**********************************************************************

subroutine definition_Tp(n,q,Tp)
implicit none
integer(kind=4),intent(in) :: n
real(kind=8),intent(in) :: q(n)
real(kind=8),intent(out) :: Tp(n/2)

Tp(1)=q(16)
Tp(2)=q(17)
Tp(3)=q(18)
Tp(4)=q(19)
Tp(5)=q(20)
Tp(6)=q(21)
Tp(7)=q(22)
Tp(8)=q(23)
Tp(9)=q(24)
Tp(10)=q(25)
Tp(11)=q(26)
Tp(12)=q(27)
Tp(13)=q(28)
Tp(14)=q(29)
Tp(15)=q(30)

return
end subroutine definition_Tp

!**********************************************************************

subroutine definition_Vq(n,q,Vq)
implicit none
integer(kind=4),intent(in) :: n
real(kind=8),intent(in) :: q(n)
real(kind=8),intent(out) :: Vq(n/2)
real(kind=8) :: beta
common /param1/ beta

Vq(2)=(2*(-q(1) + q(2)) - 2*(-q(2) + q(3)))/2. + (beta*(4*(-q(1) + q(2))**3 - 4*(-q(2) + q(3))**3))/4.
Vq(3)=(2*(-q(2) + q(3)) - 2*(-q(3) + q(4)))/2. + (beta*(4*(-q(2) + q(3))**3 - 4*(-q(3) + q(4))**3))/4.
Vq(4)=(2*(-q(3) + q(4)) - 2*(-q(4) + q(5)))/2. + (beta*(4*(-q(3) + q(4))**3 - 4*(-q(4) + q(5))**3))/4.
Vq(5)=(2*(-q(4) + q(5)) - 2*(-q(5) + q(6)))/2. + (beta*(4*(-q(4) + q(5))**3 - 4*(-q(5) + q(6))**3))/4.
Vq(6)=(2*(-q(5) + q(6)) - 2*(-q(6) + q(7)))/2. + (beta*(4*(-q(5) + q(6))**3 - 4*(-q(6) + q(7))**3))/4.
Vq(7)=(2*(-q(6) + q(7)) - 2*(-q(7) + q(8)))/2. + (beta*(4*(-q(6) + q(7))**3 - 4*(-q(7) + q(8))**3))/4.
Vq(8)=(2*(-q(7) + q(8)) - 2*(-q(8) + q(9)))/2. + (beta*(4*(-q(7) + q(8))**3 - 4*(-q(8) + q(9))**3))/4.
Vq(9)=(2*(-q(8) + q(9)) - 2*(-q(9) + q(10)))/2. + (beta*(4*(-q(8) + q(9))**3 - 4*(-q(9) + q(10))**3))/4.
Vq(10)=(2*(-q(9) + q(10)) - 2*(-q(10) + q(11)))/2. + (beta*(4*(-q(9) + q(10))**3 - 4*(-q(10) + q(11))**3))/4.
Vq(11)=(2*(-q(10) + q(11)) - 2*(-q(11) + q(12)))/2. + (beta*(4*(-q(10) + q(11))**3 - 4*(-q(11) + q(12))**3))/4.
Vq(12)=(2*(-q(11) + q(12)) - 2*(-q(12) + q(13)))/2. + (beta*(4*(-q(11) + q(12))**3 - 4*(-q(12) + q(13))**3))/4.
Vq(13)=(2*(-q(12) + q(13)) - 2*(-q(13) + q(14)))/2. + (beta*(4*(-q(12) + q(13))**3 - 4*(-q(13) + q(14))**3))/4.
Vq(14)=(2*(-q(13) + q(14)) - 2*(-q(14) + q(15)))/2. + (beta*(4*(-q(13) + q(14))**3 - 4*(-q(14) + q(15))**3))/4.

return
end subroutine definition_Vq

!**********************************************************************

subroutine definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)
implicit none
integer(kind=4),intent(in) :: n, numberofdeviationvectors, index
real(kind=8),intent(in) :: q((1+numberofdeviationvectors)*n)
real(kind=8),intent(out) :: TDHTp(n/2,numberofdeviationvectors)

TDHTp(1,index)=q(1 + 15*(1 + 2*index))
TDHTp(2,index)=q(2 + 15*(1 + 2*index))
TDHTp(3,index)=q(3 + 15*(1 + 2*index))
TDHTp(4,index)=q(4 + 15*(1 + 2*index))
TDHTp(5,index)=q(5 + 15*(1 + 2*index))
TDHTp(6,index)=q(6 + 15*(1 + 2*index))
TDHTp(7,index)=q(7 + 15*(1 + 2*index))
TDHTp(8,index)=q(8 + 15*(1 + 2*index))
TDHTp(9,index)=q(9 + 15*(1 + 2*index))
TDHTp(10,index)=q(10 + 15*(1 + 2*index))
TDHTp(11,index)=q(11 + 15*(1 + 2*index))
TDHTp(12,index)=q(12 + 15*(1 + 2*index))
TDHTp(13,index)=q(13 + 15*(1 + 2*index))
TDHTp(14,index)=q(14 + 15*(1 + 2*index))
TDHTp(15,index)=q(15 + 15*(1 + 2*index))

return
end subroutine definition_TDHTp

!**********************************************************************

subroutine definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)
implicit none
integer(kind=4),intent(in) :: n, numberofdeviationvectors, index
real(kind=8),intent(in) :: q((1+numberofdeviationvectors)*n)
real(kind=8),intent(out) :: TDHVq(n/2,numberofdeviationvectors)
real(kind=8) :: beta
common /param1/ beta

TDHVq(2,index)=(2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(1 + 30*index) + 2*(2 + (beta*(12*(-q(1) + q(2))**2 + 12*(-q(2) + q(3))**2))/4.)*q(2 + 30*index) + 2*(-1 - 3*beta*(-q(2) + q(3))**2)*q(3 + 30*index))/2.
TDHVq(3,index)=(2*(-1 - 3*beta*(-q(2) + q(3))**2)*q(2 + 30*index) + 2*(2 + (beta*(12*(-q(2) + q(3))**2 + 12*(-q(3) + q(4))**2))/4.)*q(3 + 30*index) + 2*(-1 - 3*beta*(-q(3) + q(4))**2)*q(4 + 30*index))/2.
TDHVq(4,index)=(2*(-1 - 3*beta*(-q(3) + q(4))**2)*q(3 + 30*index) + 2*(2 + (beta*(12*(-q(3) + q(4))**2 + 12*(-q(4) + q(5))**2))/4.)*q(4 + 30*index) + 2*(-1 - 3*beta*(-q(4) + q(5))**2)*q(5 + 30*index))/2.
TDHVq(5,index)=(2*(-1 - 3*beta*(-q(4) + q(5))**2)*q(4 + 30*index) + 2*(2 + (beta*(12*(-q(4) + q(5))**2 + 12*(-q(5) + q(6))**2))/4.)*q(5 + 30*index) + 2*(-1 - 3*beta*(-q(5) + q(6))**2)*q(6 + 30*index))/2.
TDHVq(6,index)=(2*(-1 - 3*beta*(-q(5) + q(6))**2)*q(5 + 30*index) + 2*(2 + (beta*(12*(-q(5) + q(6))**2 + 12*(-q(6) + q(7))**2))/4.)*q(6 + 30*index) + 2*(-1 - 3*beta*(-q(6) + q(7))**2)*q(7 + 30*index))/2.
TDHVq(7,index)=(2*(-1 - 3*beta*(-q(6) + q(7))**2)*q(6 + 30*index) + 2*(2 + (beta*(12*(-q(6) + q(7))**2 + 12*(-q(7) + q(8))**2))/4.)*q(7 + 30*index) + 2*(-1 - 3*beta*(-q(7) + q(8))**2)*q(8 + 30*index))/2.
TDHVq(8,index)=(2*(-1 - 3*beta*(-q(7) + q(8))**2)*q(7 + 30*index) + 2*(2 + (beta*(12*(-q(7) + q(8))**2 + 12*(-q(8) + q(9))**2))/4.)*q(8 + 30*index) + 2*(-1 - 3*beta*(-q(8) + q(9))**2)*q(9 + 30*index))/2.
TDHVq(9,index)=(2*(-1 - 3*beta*(-q(8) + q(9))**2)*q(8 + 30*index) + 2*(2 + (beta*(12*(-q(8) + q(9))**2 + 12*(-q(9) + q(10))**2))/4.)*q(9 + 30*index) + 2*(-1 - 3*beta*(-q(9) + q(10))**2)*q(10 + 30*index))/2.
TDHVq(10,index)=(2*(-1 - 3*beta*(-q(9) + q(10))**2)*q(9 + 30*index) + 2*(2 + (beta*(12*(-q(9) + q(10))**2 + 12*(-q(10) + q(11))**2))/4.)*q(10 + 30*index) + 2*(-1 - 3*beta*(-q(10) + q(11))**2)*q(11 + 30*index))/2.
TDHVq(11,index)=(2*(-1 - 3*beta*(-q(10) + q(11))**2)*q(10 + 30*index) + 2*(2 + (beta*(12*(-q(10) + q(11))**2 + 12*(-q(11) + q(12))**2))/4.)*q(11 + 30*index) + 2*(-1 - 3*beta*(-q(11) + q(12))**2)*q(12 + 30*index))/2.
TDHVq(12,index)=(2*(-1 - 3*beta*(-q(11) + q(12))**2)*q(11 + 30*index) + 2*(2 + (beta*(12*(-q(11) + q(12))**2 + 12*(-q(12) + q(13))**2))/4.)*q(12 + 30*index) + 2*(-1 - 3*beta*(-q(12) + q(13))**2)*q(13 + 30*index))/2.
TDHVq(13,index)=(2*(-1 - 3*beta*(-q(12) + q(13))**2)*q(12 + 30*index) + 2*(2 + (beta*(12*(-q(12) + q(13))**2 + 12*(-q(13) + q(14))**2))/4.)*q(13 + 30*index) + 2*(-1 - 3*beta*(-q(13) + q(14))**2)*q(14 + 30*index))/2.
TDHVq(14,index)=(2*(-1 - 3*beta*(-q(13) + q(14))**2)*q(13 + 30*index) + 2*(2 + (beta*(12*(-q(13) + q(14))**2 + 12*(-q(14) + q(15))**2))/4.)*q(14 + 30*index) + 2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(15 + 30*index))/2.

return
end subroutine definition_TDHVq

!**********************************************************************

subroutine si_mapping_1st_order(n,numberofdeviationvectors,q,tstep)
implicit none
integer(kind=4),intent(in) :: n, numberofdeviationvectors
real(kind=8),intent(in) :: tstep
real(kind=8),intent(inout) :: q((1+numberofdeviationvectors)*n)
integer(kind=4) :: i, index
real(kind=8) :: Tp(n/2), Vq(n/2), TDHTp(n/2,numberofdeviationvectors), TDHVq(n/2,numberofdeviationvectors)
real(kind=8) :: beta
common /param1/ beta

call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*1.*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.*Vq(i)
enddo
q(n)=-1.*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*1.*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.5*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.5*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

return
end subroutine si_mapping_1st_order

!**********************************************************************

subroutine si_mapping_2nd_order(n,numberofdeviationvectors,q,tstep)
implicit none
integer(kind=4),intent(in) :: n, numberofdeviationvectors
real(kind=8),intent(in) :: tstep
real(kind=8),intent(inout) :: q((1+numberofdeviationvectors)*n)
integer(kind=4) :: i, index
real(kind=8) :: Tp(n/2), Vq(n/2), TDHTp(n/2,numberofdeviationvectors), TDHVq(n/2,numberofdeviationvectors)
real(kind=8) :: beta
common /param1/ beta

call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.5*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.*Vq(i)
enddo
q(n)=-1.*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.5*Tp(i)
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.5*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.5*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.5*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.5*TDHTp(i-index*n,index)
    enddo
enddo

return
end subroutine si_mapping_2nd_order

!**********************************************************************

subroutine si_mapping_3rd_order(n,numberofdeviationvectors,q,tstep)
implicit none
integer(kind=4),intent(in) :: n, numberofdeviationvectors
real(kind=8),intent(in) :: tstep
real(kind=8),intent(inout) :: q((1+numberofdeviationvectors)*n)
integer(kind=4) :: i, index
real(kind=8) :: Tp(n/2), Vq(n/2), TDHTp(n/2,numberofdeviationvectors), TDHVq(n/2,numberofdeviationvectors)
real(kind=8) :: beta
common /param1/ beta

call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.2916666666666667*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-0.6666666666666667*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*0.6666666666666667*Vq(i)
enddo
q(n)=-0.6666666666666667*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.75*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=0.6666666666666667*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-0.6666666666666667*Vq(i)
enddo
q(n)=0.6666666666666667*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-0.04166666666666667*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.*Vq(i)
enddo
q(n)=-1.*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.2916666666666667*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.3333333333333333*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*0.6666666666666667*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.3333333333333333*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.75*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=0.3333333333333333*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-0.6666666666666667*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=0.3333333333333333*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-0.04166666666666667*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.5*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.5*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

return
end subroutine si_mapping_3rd_order

!**********************************************************************

subroutine si_mapping_4th_order(n,numberofdeviationvectors,q,tstep)
implicit none
integer(kind=4),intent(in) :: n, numberofdeviationvectors
real(kind=8),intent(in) :: tstep
real(kind=8),intent(inout) :: q((1+numberofdeviationvectors)*n)
integer(kind=4) :: i, index
real(kind=8) :: Tp(n/2), Vq(n/2), TDHTp(n/2,numberofdeviationvectors), TDHVq(n/2,numberofdeviationvectors)
real(kind=8) :: beta
common /param1/ beta

call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.675603595979829*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.351207191959658*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.351207191959658*Vq(i)
enddo
q(n)=-1.351207191959658*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-0.175603595979829*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=1.70241438391932*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-1.70241438391932*Vq(i)
enddo
q(n)=1.70241438391932*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-0.175603595979829*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.351207191959658*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.351207191959658*Vq(i)
enddo
q(n)=-1.351207191959658*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.675603595979829*Tp(i)
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.675603595979829*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.675603595979829*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.351207191959658*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.675603595979829*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-0.175603595979829*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=0.851207191959658*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-1.70241438391932*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=0.851207191959658*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-0.175603595979829*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.675603595979829*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.351207191959658*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.675603595979829*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.675603595979829*TDHTp(i-index*n,index)
    enddo
enddo

return
end subroutine si_mapping_4th_order

!**********************************************************************

subroutine si_mapping_6th_order(n,numberofdeviationvectors,q,tstep)
implicit none
integer(kind=4),intent(in) :: n, numberofdeviationvectors
real(kind=8),intent(in) :: tstep
real(kind=8),intent(inout) :: q((1+numberofdeviationvectors)*n)
integer(kind=4) :: i, index
real(kind=8) :: Tp(n/2), Vq(n/2), TDHTp(n/2,numberofdeviationvectors), TDHVq(n/2,numberofdeviationvectors)
real(kind=8) :: beta
common /param1/ beta

call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.72389128119965*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.4477825623993*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.4477825623993*Vq(i)
enddo
q(n)=-1.4477825623993*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-0.34812637695304505*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=2.14403531630539*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-2.14403531630539*Vq(i)
enddo
q(n)=2.14403531630539*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-1.0712532270105704*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-0.00152886228424922*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*0.00152886228424922*Vq(i)
enddo
q(n)=-0.00152886228424922*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*1.1954883227639654*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-2.3894477832436816*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*2.3894477832436816*Vq(i)
enddo
q(n)=-2.3894477832436816*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*1.1954883227639654*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-0.00152886228424922*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*0.00152886228424922*Vq(i)
enddo
q(n)=-0.00152886228424922*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-1.0712532270105704*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=2.14403531630539*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-2.14403531630539*Vq(i)
enddo
q(n)=2.14403531630539*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-0.34812637695304505*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.4477825623993*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.4477825623993*Vq(i)
enddo
q(n)=-1.4477825623993*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.72389128119965*Tp(i)
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.72389128119965*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.72389128119965*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.4477825623993*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.72389128119965*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-0.34812637695304505*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=1.072017658152695*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-2.14403531630539*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=1.072017658152695*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-1.0712532270105704*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.00076443114212461*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*0.00152886228424922*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.00076443114212461*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*1.1954883227639654*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-1.1947238916218408*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*2.3894477832436816*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-1.1947238916218408*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*1.1954883227639654*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.00076443114212461*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*0.00152886228424922*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.00076443114212461*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-1.0712532270105704*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=1.072017658152695*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-2.14403531630539*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=1.072017658152695*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-0.34812637695304505*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.72389128119965*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.4477825623993*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.72389128119965*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.72389128119965*TDHTp(i-index*n,index)
    enddo
enddo

return
end subroutine si_mapping_6th_order

!**********************************************************************

subroutine si_mapping_8th_order(n,numberofdeviationvectors,q,tstep)
implicit none
integer(kind=4),intent(in) :: n, numberofdeviationvectors
real(kind=8),intent(in) :: tstep
real(kind=8),intent(inout) :: q((1+numberofdeviationvectors)*n)
integer(kind=4) :: i, index
real(kind=8) :: Tp(n/2), Vq(n/2), TDHTp(n/2,numberofdeviationvectors), TDHVq(n/2,numberofdeviationvectors)
real(kind=8) :: beta
common /param1/ beta

call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.521213104349955*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.04242620869991*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.04242620869991*Vq(i)
enddo
q(n)=-1.04242620869991*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*1.4313162592035251*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.82020630970714*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.82020630970714*Vq(i)
enddo
q(n)=-1.82020630970714*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.9889731189153784*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-0.157739928123617*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*0.157739928123617*Vq(i)
enddo
q(n)=-0.157739928123617*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*1.2988836271454833*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-2.4400273261673497*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*2.4400273261673497*Vq(i)
enddo
q(n)=-2.4400273261673497*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*1.2164287159851344*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=0.007169894197081201*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-0.007169894197081201*Vq(i)
enddo
q(n)=0.007169894197081201*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-1.2270808589511604*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=2.4469918237052397*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-2.4469918237052397*Vq(i)
enddo
q(n)=2.4469918237052397*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-2.0314077826031047*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=1.61582374150097*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-1.61582374150097*Vq(i)
enddo
q(n)=1.61582374150097*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-1.6983261840452109*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=1.780828626589452*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-1.780828626589452*Vq(i)
enddo
q(n)=1.780828626589452*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-1.6983261840452109*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=1.61582374150097*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-1.61582374150097*Vq(i)
enddo
q(n)=1.61582374150097*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-2.0314077826031047*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=2.4469918237052397*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-2.4469918237052397*Vq(i)
enddo
q(n)=2.4469918237052397*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*-1.2270808589511604*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=0.007169894197081201*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*-0.007169894197081201*Vq(i)
enddo
q(n)=0.007169894197081201*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*1.2164287159851344*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-2.4400273261673497*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*2.4400273261673497*Vq(i)
enddo
q(n)=-2.4400273261673497*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*1.2988836271454833*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-0.157739928123617*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*0.157739928123617*Vq(i)
enddo
q(n)=-0.157739928123617*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.9889731189153784*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.82020630970714*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.82020630970714*Vq(i)
enddo
q(n)=-1.82020630970714*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*1.4313162592035251*Tp(i)
enddo

call definition_Vq(n,q,Vq)

q(1 + n/2.)=-1.04242620869991*tstep*((2*q(1) - 2*(-q(1) + q(2)))/2. + (beta*(4*q(1)**3 - 4*(-q(1) + q(2))**3))/4.) + q(16)
do i=2,n/2-1
    q(i+n/2)=q(i+n/2)-tstep*1.04242620869991*Vq(i)
enddo
q(n)=-1.04242620869991*tstep*((2*q(15) + 2*(-q(14) + q(15)))/2. + (beta*(4*q(15)**3 + 4*(-q(14) + q(15))**3))/4.) + q(30)


call definition_Tp(n,q,Tp)

do i=1,n/2
    q(i)=q(i)+tstep*0.521213104349955*Tp(i)
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.521213104349955*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.521213104349955*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.04242620869991*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.521213104349955*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*1.4313162592035251*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.91010315485357*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.82020630970714*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.91010315485357*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.9889731189153784*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.0788699640618085*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*0.157739928123617*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.0788699640618085*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*1.2988836271454833*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-1.2200136630836749*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*2.4400273261673497*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-1.2200136630836749*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*1.2164287159851344*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=0.0035849470985406004*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-0.007169894197081201*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=0.0035849470985406004*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-1.2270808589511604*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=1.2234959118526199*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-2.4469918237052397*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=1.2234959118526199*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-2.0314077826031047*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=0.807911870750485*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-1.61582374150097*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=0.807911870750485*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-1.6983261840452109*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=0.890414313294726*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-1.780828626589452*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=0.890414313294726*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-1.6983261840452109*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=0.807911870750485*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-1.61582374150097*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=0.807911870750485*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-2.0314077826031047*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=1.2234959118526199*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-2.4469918237052397*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=1.2234959118526199*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*-1.2270808589511604*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=0.0035849470985406004*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*-0.007169894197081201*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=0.0035849470985406004*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*1.2164287159851344*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-1.2200136630836749*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*2.4400273261673497*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-1.2200136630836749*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*1.2988836271454833*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.0788699640618085*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*0.157739928123617*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.0788699640618085*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.9889731189153784*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.91010315485357*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.82020630970714*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.91010315485357*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*1.4313162592035251*TDHTp(i-index*n,index)
    enddo

    call definition_TDHVq(n,numberofdeviationvectors,index,q,TDHVq)

    q(1+index*n+n/2)=-0.521213104349955*tstep*(2*(2 + (beta*(12*q(1)**2 + 12*(-q(1) + q(2))**2))/4.)*q(1 + 30*index) + 2*(-1 - 3*beta*(-q(1) + q(2))**2)*q(2 + 30*index)) + q(1 + 15*(1 + 2*index))
    do i=2+index*n,n/2-1+index*n
        q(i+n/2)=q(i+n/2)-tstep*1.04242620869991*TDHVq(i-index*n,index)
    enddo
    q((1+index)*n)=-0.521213104349955*tstep*(2*(-1 - 3*beta*(-q(14) + q(15))**2)*q(14 + 30*index) + 2*(2 + (beta*(12*q(15)**2 + 12*(-q(14) + q(15))**2))/4.)*q(15 + 30*index)) + q(15 + 15*(1 + 2*index))
enddo

do index=1,numberofdeviationvectors
    call definition_TDHTp(n,numberofdeviationvectors,index,q,TDHTp)

    do i=1+(index*n),index*n+n/2
        q(i)=q(i)+tstep*0.521213104349955*TDHTp(i-index*n,index)
    enddo
enddo

return
end subroutine si_mapping_8th_order

!**************************************************************

function hpart1_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: beta, hpart1_function
common /param1/ beta

hpart1_function= (q(1)**2 + (-q(1) + q(2))**2 + (-q(2) + q(3))**2 + (-q(3) + q(4))**2 + (-q(4) + q(5))**2 + (-q(5) + q(6))**2 + (-q(6) + q(7))**2)/2. + (beta*(q(1)**4 + (-q(1) + q(2))**4 + (-q(2) + q(3))**4 + (-q(3) + q(4))**4 + (-q(4) + q(5))**4 + (-q(5) + q(6))**4 + (-q(6) + q(7))**4))/4. + (-q(7.5) + q(8.5))**2/4. + (beta*(-q(7.5) + q(8.5))**4)/8. + (q(16)**2 + q(17)**2 + q(18)**2 + q(19)**2 + q(20)**2 + q(21)**2 + q(22)**2)/2.

return
end function hpart1_function

!**************************************************************

function hpart2_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: beta, hpart2_function
common /param1/ beta

hpart2_function= (-q(7.5) + q(8.5))**2/4. + (beta*(-q(7.5) + q(8.5))**4)/8. + ((-q(8.5) + q(9.5))**2 + (-q(9.5) + q(10.5))**2 + (-q(10.5) + q(11.5))**2 + (-q(11.5) + q(12.5))**2 + (-q(12.5) + q(13.5))**2 + (-q(13.5) + q(14.5))**2 + (-q(14.5) + q(15.5))**2)/2. + (beta*((-q(8.5) + q(9.5))**4 + (-q(9.5) + q(10.5))**4 + (-q(10.5) + q(11.5))**4 + (-q(11.5) + q(12.5))**4 + (-q(12.5) + q(13.5))**4 + (-q(13.5) + q(14.5))**4 + (-q(14.5) + q(15.5))**4))/4. + (q(23.5)**2 + q(24.5)**2 + q(25.5)**2 + q(26.5)**2 + q(27.5)**2 + q(28.5)**2 + q(29.5)**2)/2.

return
end function hpart2_function

!**************************************************************

function hkineticpart1_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: hkineticpart1_function

hkineticpart1_function= (q(16)**2 + q(17)**2 + q(18)**2 + q(19)**2 + q(20)**2 + q(21)**2 + q(22)**2)/2.

return
end function hkineticpart1_function

!**************************************************************

function hpotentialpart1_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: beta, hpotentialpart1_function
common /param1/ beta

hpotentialpart1_function= (q(1)**2 + (-q(1) + q(2))**2 + (-q(2) + q(3))**2 + (-q(3) + q(4))**2 + (-q(4) + q(5))**2 + (-q(5) + q(6))**2 + (-q(6) + q(7))**2)/2. + (beta*(q(1)**4 + (-q(1) + q(2))**4 + (-q(2) + q(3))**4 + (-q(3) + q(4))**4 + (-q(4) + q(5))**4 + (-q(5) + q(6))**4 + (-q(6) + q(7))**4))/4. + (-q(7.5) + q(8.5))**2/4. + (beta*(-q(7.5) + q(8.5))**4)/8.

return
end function hpotentialpart1_function

!**************************************************************

function hkineticpart2_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: hkineticpart2_function

hkineticpart2_function= (q(23.5)**2 + q(24.5)**2 + q(25.5)**2 + q(26.5)**2 + q(27.5)**2 + q(28.5)**2 + q(29.5)**2)/2.

return
end function hkineticpart2_function

!**************************************************************

function hpotentialpart2_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: beta, hpotentialpart2_function
common /param1/ beta

hpotentialpart2_function= (-q(7.5) + q(8.5))**2/4. + (beta*(-q(7.5) + q(8.5))**4)/8. + ((-q(8.5) + q(9.5))**2 + (-q(9.5) + q(10.5))**2 + (-q(10.5) + q(11.5))**2 + (-q(11.5) + q(12.5))**2 + (-q(12.5) + q(13.5))**2 + (-q(13.5) + q(14.5))**2 + (-q(14.5) + q(15.5))**2)/2. + (beta*((-q(8.5) + q(9.5))**4 + (-q(9.5) + q(10.5))**4 + (-q(10.5) + q(11.5))**4 + (-q(11.5) + q(12.5))**4 + (-q(12.5) + q(13.5))**4 + (-q(13.5) + q(14.5))**4 + (-q(14.5) + q(15.5))**4))/4.

return
end function hpotentialpart2_function

!**************************************************************

function kinetic_energy_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: kinetic_energy_function

kinetic_energy_function= (q(16)**2 + q(17)**2 + q(18)**2 + q(19)**2 + q(20)**2 + q(21)**2 + q(22)**2 + q(23)**2 + q(24)**2 + q(25)**2 + q(26)**2 + q(27)**2 + q(28)**2 + q(29)**2 + q(30)**2)/2.

return
end function kinetic_energy_function

!**************************************************************

function potential_energy_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: beta, potential_energy_function
common /param1/ beta

potential_energy_function= (q(1)**2 + (-q(1) + q(2))**2 + (-q(2) + q(3))**2 + (-q(3) + q(4))**2 + (-q(4) + q(5))**2 + (-q(5) + q(6))**2 + (-q(6) + q(7))**2 + (-q(7) + q(8))**2 + (-q(8) + q(9))**2 + (-q(9) + q(10))**2 + (-q(10) + q(11))**2 + (-q(11) + q(12))**2 + (-q(12) + q(13))**2 + (-q(13) + q(14))**2 + q(15)**2 + (-q(14) + q(15))**2)/2. + (beta*(q(1)**4 + (-q(1) + q(2))**4 + (-q(2) + q(3))**4 + (-q(3) + q(4))**4 + (-q(4) + q(5))**4 + (-q(5) + q(6))**4 + (-q(6) + q(7))**4 + (-q(7) + q(8))**4 + (-q(8) + q(9))**4 + (-q(9) + q(10))**4 + (-q(10) + q(11))**4 + (-q(11) + q(12))**4 + (-q(12) + q(13))**4 + (-q(13) + q(14))**4 + q(15)**4 + (-q(14) + q(15))**4))/4.

return
end function potential_energy_function

!**************************************************************

function kinetic_energy_derivative_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: beta, kinetic_energy_derivative_function
common /param1/ beta

kinetic_energy_derivative_function= (-2*q(1) + q(2) + beta*(-q(1)**3 + (-q(1) + q(2))**3))*q(16) + (q(1) - 2*q(2) + q(3) + beta*(-(-q(1) + q(2))**3 + (-q(2) + q(3))**3))*q(17) + (q(2) - 2*q(3) + q(4) + beta*(-(-q(2) + q(3))**3 + (-q(3) + q(4))**3))*q(18) + (q(3) - 2*q(4) + q(5) + beta*(-(-q(3) + q(4))**3 + (-q(4) + q(5))**3))*q(19) + (q(4) - 2*q(5) + q(6) + beta*(-(-q(4) + q(5))**3 + (-q(5) + q(6))**3))*q(20) + (q(5) - 2*q(6) + q(7) + beta*(-(-q(5) + q(6))**3 + (-q(6) + q(7))**3))*q(21) + (q(6) - 2*q(7) + q(8) + beta*(-(-q(6) + q(7))**3 + (-q(7) + q(8))**3))*q(22) + (q(7) - 2*q(8) + q(9) + beta*(-(-q(7) + q(8))**3 + (-q(8) + q(9))**3))*q(23) + (q(8) - 2*q(9) + q(10) + beta*(-(-q(8) + q(9))**3 + (-q(9) + q(10))**3))*q(24) + (q(9) - 2*q(10) + q(11) + beta*(-(-q(9) + q(10))**3 + (-q(10) + q(11))**3))*q(25) + (q(10) - 2*q(11) + q(12) + beta*(-(-q(10) + q(11))**3 + (-q(11) + q(12))**3))*q(26) + (q(11) - 2*q(12) + q(13) + beta*(-(-q(11) + q(12))**3 + (-q(12) + q(13))**3))*q(27) + (q(12) - 2*q(13) + q(14) + beta*(-(-q(12) + q(13))**3 + (-q(13) + q(14))**3))*q(28) + (q(13) - 2*q(14) + q(15) + beta*(-(-q(13) + q(14))**3 + (-q(14) + q(15))**3))*q(29) + (q(14) - 2*q(15) + beta*(-q(15)**3 - (-q(14) + q(15))**3))*q(30)

return
end function kinetic_energy_derivative_function

!**************************************************************

function potential_energy_derivative_function(q,n)
implicit none
integer(kind=4),intent(in):: n
real(kind=8),intent(in):: q(n)
real(kind=8):: beta, potential_energy_derivative_function
common /param1/ beta

potential_energy_derivative_function= q(1)*q(16) + beta*q(1)**3*q(16) + (-q(1) + q(2))*(-q(16) + q(17)) + beta*(-q(1) + q(2))**3*(-q(16) + q(17)) + (-q(2) + q(3))*(-q(17) + q(18)) + beta*(-q(2) + q(3))**3*(-q(17) + q(18)) + (-q(3) + q(4))*(-q(18) + q(19)) + beta*(-q(3) + q(4))**3*(-q(18) + q(19)) + (-q(4) + q(5))*(-q(19) + q(20)) + beta*(-q(4) + q(5))**3*(-q(19) + q(20)) + (-q(5) + q(6))*(-q(20) + q(21)) + beta*(-q(5) + q(6))**3*(-q(20) + q(21)) + (-q(6) + q(7))*(-q(21) + q(22)) + beta*(-q(6) + q(7))**3*(-q(21) + q(22)) + (-q(7) + q(8))*(-q(22) + q(23)) + beta*(-q(7) + q(8))**3*(-q(22) + q(23)) + (-q(8) + q(9))*(-q(23) + q(24)) + beta*(-q(8) + q(9))**3*(-q(23) + q(24)) + (-q(9) + q(10))*(-q(24) + q(25)) + beta*(-q(9) + q(10))**3*(-q(24) + q(25)) + (-q(10) + q(11))*(-q(25) + q(26)) + beta*(-q(10) + q(11))**3*(-q(25) + q(26)) + (-q(11) + q(12))*(-q(26) + q(27)) + beta*(-q(11) + q(12))**3*(-q(26) + q(27)) + (-q(12) + q(13))*(-q(27) + q(28)) + beta*(-q(12) + q(13))**3*(-q(27) + q(28)) + (-q(13) + q(14))*(-q(28) + q(29)) + beta*(-q(13) + q(14))**3*(-q(28) + q(29)) + q(15)*q(30) + beta*q(15)**3*q(30) + (-q(14) + q(15))*(-q(29) + q(30)) + beta*(-q(14) + q(15))**3*(-q(29) + q(30))

return
end function potential_energy_derivative_function
!**************************************************************
